﻿# ##########################################################################
# Programme Python permettant de tracer les positions d'un point M
# à partir d'abscisses et d'ordonnées issues d'un pointage (ou d'équations).
# et de tracer le vecteur vitesse en un point
# à destination des élèves qui peuvent modifier le code sous les parties roses

# L'utilisation des listes NUMPY permet de simplifier le code
# ##########################################################################
# O. CHAUMETTE - Lycée JP SARTRE - 69500 BRON - olivier.chaumette@ac-lyon.fr
# ##########################################################################


# ##########################
# IMPORTATION DES MODULES #
# #########################
# importation de NUMPY (pour gestion tableaux et calculs) sous l'alias "np"
import numpy as np
# importation de PYPLOT (du module MATPLOTLIB, pour le tracé de courbes) sous l'alias "plt"
import matplotlib.pyplot as plt

import os
os.environ["QT_API"]="pyqt5"

# modules permettant d'importer des données
# le fichier "import_donnees.py" est indispensable
from import_donnees_meca import traiteDonnees


# Initialisation des tableaux numpy contenant x,y,t
x=np.array([])
y=np.array([])
t=np.array([])


# #################################
# Fonction qui simplifie le tracé du vecteur vitesse
# afin que l'élève n'ait pas à définir l'origine
# du vecteur en termes de coordonnées
# (pour ne pas mélanger des positions et des coordonées de vecteurs)
# #################################
def draw_Vector(numero_du_point, abscisse_vecteur, ordonnee_vecteur, couleur):
    global x,y
    plt.quiver(x[numero_du_point], y[numero_du_point],abscisse_vecteur,ordonnee_vecteur,color=couleur,scale=20)




""" ---------------------------------
        CHOIX du PROFESSEUR
------------------------------------- """
#  Logiciel utilisé à choisir parmi :
# 'pymecavideo'     (exporter un fichier TXT)
# 'latispro'        (fichier TXT créé par LATISPRO, avec décimale VIRGULE et séparation POINT VIRGULE)
# 'avimeca'         (crééer un fichier TXT en export)
# 'avistep'         (pointage exporté depuis AVISTEP:
# 'equation'        (équation paramétrées saisies dans le fichier "import_donnees")
# 'entrees'        (données de pointage saisies "à la main" dans le fichier "import_donnees.py)

Logiciel_Utilise = 'equation'

""" ---------------------------------
        FIN du CHOIX du PROFESSEUR
------------------------------------- """

t, x, y = traiteDonnees(Logiciel_Utilise)


# #####################################
# Tracé de la trajectoire
# #####################################

plt.plot(x,y,"rx-")
plt.title("Trajectoire")          # titre du graphique
plt.xlabel("abscisse (m)")         # nom de la grandeur sur l'axe X
plt.ylabel("ordonnée (m)")         # nom de la grandeur sur l'axe Y


""" ###########################################
Ici commence le travail à réaliser par les élèves
################################################# """

""" TRAVAIL 1:
Taper ci-dessous le code python permettant:
    - de mettre dans une variable Vx l'abscisse du vecteur vitesse au point 2
    - de mettre dans une variable Vy l'ordonnée du vecteur vitesse au point 2 """
#Vx=(x[3]-x[2])/(t[3]-t[2])
#Vy= (y[3]-y[2])/(t[3]-t[2])

""" TRAVAIL 2:
Taper ci-dessous le code python permettant
de tracer le vecteur vitesse au point 5 en bleu"""
#draw_Vector(2,Vx,Vy,'b')


""" TRAVAIL 3:
    Généralisation
Taper ci-dessous le code python permettant:
    - créer une variable nommée n correspondant à un numéro de point quelconque (3 par exemple)
    - de mettre dans une variable Vx1 l'abscisse du vecteur vitesse au point n
    - de mettre dans une variable Vy1 l'ordonnée du vecteur vitesse au point n
    - de tracer le vecteur vitesse au point n en vert
    - de mettre dans une variable Vx2 l'abscisse du vecteur vitesse au point n+2
    - de mettre dans une variable Vy2 l'ordonnée du vecteur vitesse au point n+2
    - de tracer le vecteur vitesse au point n+2 en rouge"""
n=10
Vx1 = (x[n+1]-x[n])/(t[n+1]-t[n])
Vy1 = (y[n+1]-y[n])/(t[n+1]-t[n])
Vx2 = (x[n+2]-x[n+1])/(t[n+2]-t[n+1])
Vy2 = (y[n+2]-y[n+1])/(t[n+2]-t[n+1])
draw_Vector(n,Vx1,Vy1,"g")
draw_Vector(n+1,Vx2,Vy2,"r")

dVx = Vx2-Vx1
dVy = Vy2-Vy1
draw_Vector(n,dVx,dVy,"k")

""" fin du travail """


# On affiche une grille
plt.grid()
# le repère doit être orthonormé:
plt.axis('equal')
# on affiche la fenêtre
#plt.get_current_fig_manager().window.state('zoomed')   # <-- Affiche la fenêtre maximisée sous windows uniquement
plt.show()
